#include "dm9000.h"
#include "delay.h"
#include "led.h"
#include "usart.h"
#include "lwip_comm.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEKսSTM32V3
//DM9000	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2015/3/15
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 

struct dm9000_config dm9000cfg;				//DM9000ýṹ

extern OS_EVENT* dm9000input;				//DM9000ź
extern OS_EVENT* dm9000lock;				//DM9000дź

//ʼDM9000
//ֵ:
//0,ʼɹ
//1DM9000A IDȡ
u8 DM9000_Init(void)
{
	u32 temp; 
	GPIO_InitTypeDef GPIO_InitStructure;
	EXTI_InitTypeDef EXTI_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	FSMC_NORSRAMInitTypeDef FSMC_NORSRAMInitStructure;
	FSMC_NORSRAMTimingInitTypeDef ReadWriteTiming; 	//DM9000Ķдʱ
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|\
						   RCC_APB2Periph_GPIOF|RCC_APB2Periph_GPIOG,ENABLE);	//ʹGPIOD E F Gʱ
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC,ENABLE);	//ʹFSMCʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);	//ʹܸùʱ

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7; 		//PD7  
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;//
	GPIO_Init(GPIOD,&GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6; 		//PG6  
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;	//
	GPIO_Init(GPIOG,&GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|\
								  GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_14|GPIO_Pin_15; //PD0 1 4 5 8 9 10 14 15
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//
	GPIO_Init(GPIOD,&GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|\
								  GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15; 			//PG7 8 9 10 11 12 13 14 15
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//
	GPIO_Init(GPIOE,&GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;		//PF13
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//
	GPIO_Init(GPIOF,&GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;		//PG9
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//
	GPIO_Init(GPIOG,&GPIO_InitStructure);
	

	//PG6ⲿжϣж6
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOG,GPIO_PinSource6);
	
	EXTI_InitStructure.EXTI_Line = EXTI_Line6;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);
	
	EXTI_ClearITPendingBit(EXTI_Line6); //ж6־λ
	
	NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;			//ⲿж6
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	//ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;			//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	ReadWriteTiming.FSMC_AddressSetupTime = 0;		//ַʱ
	ReadWriteTiming.FSMC_AddressHoldTime = 0;
	ReadWriteTiming.FSMC_DataSetupTime = 3;		//ݽʱ
	ReadWriteTiming.FSMC_BusTurnAroundDuration = 0x00;
	ReadWriteTiming.FSMC_CLKDivision = 0x00;
	ReadWriteTiming.FSMC_DataLatency = 0x00;
	ReadWriteTiming.FSMC_AccessMode = FSMC_AccessMode_A;//ʹģʽA
	
	FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM2;	//NE2
	FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
	FSMC_NORSRAMInitStructure.FSMC_MemoryType = FSMC_MemoryType_SRAM;
	FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
	FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
	FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait = FSMC_AsynchronousWait_Disable;
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
	FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
	FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
	FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
	FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
	FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable;
	FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &ReadWriteTiming;
	FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &ReadWriteTiming;
	FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure);
	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM2,ENABLE); //ʹFSMCBank1_Bank1_NORSRAM2
	
	temp=*(vu32*)(0x1FFFF7E8);				//ȡSTM32ΨһIDǰ24λΪMACַֽ
	dm9000cfg.mode=DM9000_AUTO;	
 	dm9000cfg.queue_packet_len=0;
	//DM9000SRAMķͺͽָԶصʼַҿж
	dm9000cfg.imr_all = IMR_PAR|IMR_PRI; 
	//ʼMACַ
	dm9000cfg.mac_addr[0]=2;
	dm9000cfg.mac_addr[1]=0;
	dm9000cfg.mac_addr[2]=0;
	dm9000cfg.mac_addr[3]=(temp>>16)&0XFF;	//ֽSTM32ΨһID
	dm9000cfg.mac_addr[4]=(temp>>8)&0XFFF;
	dm9000cfg.mac_addr[5]=temp&0XFF;
	//ʼ鲥ַ
	dm9000cfg.multicase_addr[0]=0Xff;
	dm9000cfg.multicase_addr[1]=0Xff;
	dm9000cfg.multicase_addr[2]=0Xff;
	dm9000cfg.multicase_addr[3]=0Xff;
	dm9000cfg.multicase_addr[4]=0Xff;
	dm9000cfg.multicase_addr[5]=0Xff;
	dm9000cfg.multicase_addr[6]=0Xff;
	dm9000cfg.multicase_addr[7]=0Xff; 
	
	DM9000_Reset();							//λDM9000
	delay_ms(100);
	temp=DM9000_Get_DeiviceID();			//ȡDM9000ID
	printf("DM9000 ID:%#x\r\n",temp);
	if(temp!=DM9000_ID) return 1; 			//ȡID
	DM9000_Set_PHYMode(dm9000cfg.mode);		//PHYģʽ
	
	DM9000_WriteReg(DM9000_NCR,0X00);
	DM9000_WriteReg(DM9000_TCR,0X00);		//ͿƼĴ
	DM9000_WriteReg(DM9000_BPTR,0X3F);	
	DM9000_WriteReg(DM9000_FCTR,0X38);
	DM9000_WriteReg(DM9000_FCR,0X00);
	DM9000_WriteReg(DM9000_SMCR,0X00);		//ģʽ
	DM9000_WriteReg(DM9000_NSR,NSR_WAKEST|NSR_TX2END|NSR_TX1END);//״̬
	DM9000_WriteReg(DM9000_ISR,0X0F);		//ж״̬
	DM9000_WriteReg(DM9000_TCR2,0X80);		//лLEDmode1 	
	//MACַ鲥ַ
	DM9000_Set_MACAddress(dm9000cfg.mac_addr);		//MACַ
	DM9000_Set_Multicast(dm9000cfg.multicase_addr);	//鲥ַ
	DM9000_WriteReg(DM9000_RCR,RCR_DIS_LONG|RCR_DIS_CRC|RCR_RXEN);
	DM9000_WriteReg(DM9000_IMR,IMR_PAR); 
	temp=DM9000_Get_SpeedAndDuplex();		//ȡDM9000ٶȺ˫״̬
	if(temp!=0XFF)							//ӳɹͨʾٶȺ˫״̬
	{
		printf("DM9000 Speed:%dMbps,Duplex:%s duplex mode\r\n",(temp&0x02)?10:100,(temp&0x01)?"Full":"Half");
	}else printf("DM9000 Establish Link Failed!\r\n");
	DM9000_WriteReg(DM9000_IMR,dm9000cfg.imr_all);	//ж
	return 0;		
} 
//ⲿж6жϷ(exti.c)
void EXTI9_5_IRQHandler(void)
{
	OSIntEnter();    
	EXTI->PR=1<<6;  			//LINE6ϵжϱ־λ   
	while(DM9000_INT==0)
	{
		DMA9000_ISRHandler();
	}
	OSIntExit();  		
} 

//ȡDM9000ָĴֵ
//reg:Ĵַ
//ֵDM9000ָĴֵ
u16 DM9000_ReadReg(u16 reg)
{
	DM9000->REG=reg;
	return DM9000->DATA; 
}
//DM9000ָĴдֵָ
//reg:ҪдļĴ
//data:Ҫдֵ
void DM9000_WriteReg(u16 reg,u16 data)
{
	DM9000->REG=reg;
	DM9000->DATA=data;
}
//ȡDM9000PHYָĴ
//reg:ҪPHYĴ
//ֵ:ȡPHYĴֵ
u16 DM9000_PHY_ReadReg(u16 reg)
{
	u16 temp;
	DM9000_WriteReg(DM9000_EPAR,DM9000_PHY|reg);
	DM9000_WriteReg(DM9000_EPCR,0X0C);				//ѡPHYͶ
	delay_ms(10);
	DM9000_WriteReg(DM9000_EPCR,0X00);				//
	temp=(DM9000_ReadReg(DM9000_EPDRH)<<8)|(DM9000_ReadReg(DM9000_EPDRL));
	return temp;
}
//DM9000PHYĴдֵָ
//reg:PHYĴ
//data:Ҫдֵ
void DM9000_PHY_WriteReg(u16 reg,u16 data)
{
	DM9000_WriteReg(DM9000_EPAR,DM9000_PHY|reg);
	DM9000_WriteReg(DM9000_EPDRL,(data&0xff));		//дֽ
	DM9000_WriteReg(DM9000_EPDRH,((data>>8)&0xff));	//дֽ
	DM9000_WriteReg(DM9000_EPCR,0X0A);				//ѡPHY,д
	delay_ms(50);
	DM9000_WriteReg(DM9000_EPCR,0X00);				//д	
} 
//ȡDM9000оƬID
//ֵDM9000оƬIDֵ
u32 DM9000_Get_DeiviceID(void)
{
	u32 value;
	value =DM9000_ReadReg(DM9000_VIDL);
	value|=DM9000_ReadReg(DM9000_VIDH) << 8;
	value|=DM9000_ReadReg(DM9000_PIDL) << 16;
	value|=DM9000_ReadReg(DM9000_PIDH) << 24;
	return value;
}
//ȡDM9000ٶȺ˫ģʽ
//ֵ	0,100M˫
//			1,100Mȫ˫
//			2,10M˫
//			3,10Mȫ˫
//			0XFF,ʧܣ
u8 DM9000_Get_SpeedAndDuplex(void)
{
	u8 temp;
	u8 i=0;	
	if(dm9000cfg.mode==DM9000_AUTO)					//ԶЭģʽһҪȴЭ
	{
		while(!(DM9000_PHY_ReadReg(0X01)&0X0020))	//ȴԶЭ
		{
			delay_ms(100);					
			i++;
			if(i>100)return 0XFF;					//ԶЭʧ
		}	
	}else											//Զģʽ,һҪȴӳɹ
	{
		while(!(DM9000_ReadReg(DM9000_NSR)&0X40))	//ȴӳɹ
		{
			delay_ms(100);					
			i++;
			if(i>100)return 0XFF;					//ʧ			
		}
	}
	temp =((DM9000_ReadReg(DM9000_NSR)>>6)&0X02);	//ȡDM9000ٶ
	temp|=((DM9000_ReadReg(DM9000_NCR)>>3)&0X01);	//ȡDM9000˫״̬
	return temp;
}

//DM900PHYģʽ
//mode:PHYģʽ
void DM9000_Set_PHYMode(u8 mode)
{
	u16 BMCR_Value,ANAR_Value;	
	switch(mode)
	{
		case DM9000_10MHD:		//10M˫
			BMCR_Value=0X0000;
			ANAR_Value=0X21;
			break;
		case DM9000_10MFD:		//10Mȫ˫
			BMCR_Value=0X0100;
			ANAR_Value=0X41;
			break;
		case DM9000_100MHD:		//100M˫
			BMCR_Value=0X2000;
			ANAR_Value=0X81;
			break;
		case DM9000_100MFD:		//100Mȫ˫
			BMCR_Value=0X2100;
			ANAR_Value=0X101;
			break;
		case DM9000_AUTO:		//ԶЭģʽ
			BMCR_Value=0X1000;
			ANAR_Value=0X01E1;
			break;		
	}
	DM9000_PHY_WriteReg(DM9000_PHY_BMCR,BMCR_Value);
	DM9000_PHY_WriteReg(DM9000_PHY_ANAR,ANAR_Value);
 	DM9000_WriteReg(DM9000_GPR,0X00);	//ʹPHY
}
//DM9000MACַ
//macaddr:ָMACַ
void DM9000_Set_MACAddress(u8 *macaddr)
{
	u8 i;
	for(i=0;i<6;i++)
	{
		DM9000_WriteReg(DM9000_PAR+i,macaddr[i]);
	}
}
//DM9000鲥ַ
//multicastaddr:ָಥַ
void DM9000_Set_Multicast(u8 *multicastaddr)
{
	u8 i;
	for(i=0;i<8;i++)
	{
		DM9000_WriteReg(DM9000_MAR+i,multicastaddr[i]);
	}
}  
//λDM9000
void DM9000_Reset(void)
{
	//λDM9000,λο<DM9000 Application Notes V1.22>ֲ29ҳ
	DM9000_RST = 0;								//DM9000Ӳλ
	delay_ms(10);
	DM9000_RST = 1; 							//DM9000Ӳλ
	delay_ms(100);								//һҪʱDM9000׼
 	DM9000_WriteReg(DM9000_GPCR,0x01);			//һ:GPCRĴ(0X1E)bit0Ϊ1 
	DM9000_WriteReg(DM9000_GPR,0);				//ڶ:GPRĴ(0X1F)bit1Ϊ0DM9000ڲPHYϵ
 	DM9000_WriteReg(DM9000_NCR,(0x02|NCR_RST));	//:λDM9000 
	do 
	{
		delay_ms(25); 	
	}while(DM9000_ReadReg(DM9000_NCR)&1);		//ȴDM9000λ
	DM9000_WriteReg(DM9000_NCR,0);
	DM9000_WriteReg(DM9000_NCR,(0x02|NCR_RST));	//DM9000ڶλ
	do 
	{
		delay_ms(25);	
	}while (DM9000_ReadReg(DM9000_NCR)&1);
}  

//ͨDM9000ݰ
//p:pbufṹָ
void DM9000_SendPacket(struct pbuf *p)
{
	struct pbuf *q;
	u16 pbuf_index = 0;
	u8 word[2], word_index = 0;
	u8 err;	
 	//printf("send len:%d\r\n",p->tot_len);
	OSMutexPend(dm9000lock,0,&err); 			//󻥳ź,DM9000 
	DM9000_WriteReg(DM9000_IMR,IMR_PAR);		//رж 
	DM9000->REG=DM9000_MWCMD;					//ʹͿԽҪ͵ݰᵽDM9000 TX SRAM	
	q=p;
	//DM9000TX SRAMдݣһдֽ
	//Ҫ͵ݳΪʱҪһֽڵдDM9000TX SRAM
 	while(q)
	{
		if (pbuf_index < q->len)
		{
			word[word_index++] = ((u8_t*)q->payload)[pbuf_index++];
			if (word_index == 2)
			{
				DM9000->DATA=((u16)word[1]<<8)|word[0];
				word_index = 0;
			}
		}else
		{
			q=q->next;
			pbuf_index = 0;
		}
	}
	//һֽδдTX SRAM
	if(word_index==1)DM9000->DATA=word[0];
	//DM9000д뷢ͳ
	DM9000_WriteReg(DM9000_TXPLL,p->tot_len&0XFF);
	DM9000_WriteReg(DM9000_TXPLH,(p->tot_len>>8)&0XFF);		//Ҫݵݳ
	DM9000_WriteReg(DM9000_TCR,0X01);						// 
	while((DM9000_ReadReg(DM9000_ISR)&0X02)==0);			//ȴ 
	DM9000_WriteReg(DM9000_ISR,0X02);						//ж 
 	DM9000_WriteReg(DM9000_IMR,dm9000cfg.imr_all);			//DM9000жʹ
	OSMutexPost(dm9000lock);								//ͻź,DM9000
}
//DM9000ݰ
//յݰDM9000RX FIFOУַΪ0X0C00~0X3FFF
//յݰǰĸֽڲʵݣض
//byte1:ǷյݣΪ0x000X01ǵĻһҪλDM9000
//		0x01յ
//		0x00δյ
//byte2:ڶֽڱʾһЩ״̬ϢDM9000RSR(0X06)Ĵһµ
//byte3:֡ݳȵĵֽ
//byte4:֡ݳȵĸֽ
//ֵpbufʽĽյݰ
struct pbuf *DM9000_Receive_Packet(void)
{
	struct pbuf* p;
	struct pbuf* q;
    u32 rxbyte;
	vu16 rx_status, rx_length;
    u16* data;
	u16 dummy; 
	int len;
	u8 err;

	p=NULL; 
	OSMutexPend(dm9000lock,0,&err); 				//󻥳ź,DM9000
__error_retry:	
	DM9000_ReadReg(DM9000_MRCMDX);					//ٶ
	rxbyte=(u8)DM9000->DATA;						//еڶζȡ 
	if(rxbyte)										//յ
	{
		if(rxbyte>1)								//rxbyte1յݴ,		
		{
            printf("dm9000 rx: rx error, stop device\r\n");
			DM9000_WriteReg(DM9000_RCR,0x00);
			DM9000_WriteReg(DM9000_ISR,0x80);		 
			return (struct pbuf*)p;
		}
		DM9000->REG=DM9000_MRCMD;
		rx_status=DM9000->DATA;
        rx_length=DM9000->DATA;  
		//if(rx_length>512)printf("rxlen:%d\r\n",rx_length);
        p=pbuf_alloc(PBUF_RAW,rx_length,PBUF_POOL);	//pbufsڴطpbuf
		if(p!=NULL)									//ڴɹ
        {
            for(q=p;q!=NULL;q=q->next)
            {
                data=(u16*)q->payload;
                len=q->len;
                while(len>0)
                {
					*data=DM9000->DATA;
                    data++;
                    len-= 2;
                }
            }
        }else										//ڴʧ
		{
			printf("pbufڴʧ:%d\r\n",rx_length);
            data=&dummy;
			len=rx_length;
			while(len)
			{
				*data=DM9000->DATA;
				len-=2;
			}
        }	
		//rx_statusжϽǷ´FIFOCRC
		//κһֵĻ֡
		//rx_lengthС64ߴݳȵʱҲ֡
		if((rx_status&0XBF00) || (rx_length < 0X40) || (rx_length > DM9000_PKT_MAX))
		{
			printf("rx_status:%#x\r\n",rx_status);
			if (rx_status & 0x100)printf("rx fifo error\r\n");
            if (rx_status & 0x200)printf("rx crc error\r\n");
            if (rx_status & 0x8000)printf("rx length error\r\n");
            if (rx_length>DM9000_PKT_MAX)
			{
				printf("rx length too big\r\n");
				DM9000_WriteReg(DM9000_NCR, NCR_RST); 	//λDM9000
				delay_ms(5);
			}
			if(p!=NULL)pbuf_free((struct pbuf*)p);		//ͷڴ
			p=NULL;
			goto __error_retry;
		}
	}else
    {
        DM9000_WriteReg(DM9000_ISR,ISR_PTS);			//жϱ־λ
        dm9000cfg.imr_all=IMR_PAR|IMR_PRI;				//½ж 
        DM9000_WriteReg(DM9000_IMR, dm9000cfg.imr_all);
    } 
	OSMutexPost(dm9000lock);							//ͻź,DM9000
	return (struct pbuf*)p; 
}
//жϴ
void DMA9000_ISRHandler(void)
{
	u16 int_status;
	u16 last_io; 
	last_io = DM9000->REG;
	int_status=DM9000_ReadReg(DM9000_ISR); 
	DM9000_WriteReg(DM9000_ISR,int_status);				//жϱ־λDM9000ISRĴbit0~bit5д1
	if(int_status & ISR_ROS)printf("overflow \r\n");
    if(int_status & ISR_ROOS)printf("overflow counter overflow \r\n");	
	if(int_status & ISR_PRS)		//ж
	{  
 		OSSemPost(dm9000input);		//յ֡ 
	} 
	if(int_status&ISR_PTS)			//ж
	{ 
									//жϴ,ûõ
	}
	DM9000->REG=last_io;	
}



































